#include <iostream>

using namespace std;

int main()
{
    int N, M, i, marker,c=false,pbr=0, u, v, br=0;
    cin>>N>>M;
    
    int a[M], b[M], t[M];
    for(i=0; i<M; i++)
    {
        cin>>a[i]>>b[i]>>t[i];    
    }
    
    
    cin>>u>>v;
    int s=0;
    for(i=0; u!=v && c==false; i++)
    {
        if(u==a[i])
        {
            u=b[i];
            if(s!=t[i])
            {
                br++;
                s=t[i];
            }
            marker = i;
            i=0;
        }
        
        if(u==v)
        {
            if(pbr<br)
                pbr=br;
            br=0;
            i=0;
            u=0;
            s=0;
            c=true;
        }
        
        if(i>=M)
        {
            u=0;
            i=0;
            br=0;
            s=0;
            a[marker]=-1;
        }
    }
    if(c==true)
    {
        cout<<pbr;
    }else
    {
        cout<<-1;
    }
    
    
    return 0;
}